package de.uka.ipd.sdq.cip.configuration;


public class Transformation {
	public enum TransformationType {
		PLAIN,
		ANNOTATED,
		HOT
	}
	
	public boolean enabled;
	public String completionPath;
	public String configPath;
	public String metamodel;
	
	public TransformationType type;
	
	public Transformation(boolean enabled, TransformationType type, String completionPath, String configPath, String metamodel) {
		this.enabled = enabled;
		this.completionPath = completionPath;
		this.configPath = configPath;
		this.type =type;
		this.metamodel = metamodel;
	}
	
	public Transformation() {
		this.enabled  = true;
		this.completionPath  = "";
		this.configPath  = "";
		this.metamodel = "";
		this.type = TransformationType.HOT;
	}

	public String toDataString() {
		String data = "";
		if(enabled)
			data += "true,";
		else
			data += "false,";
		if(type == TransformationType.HOT)
			data += "HOT,";
		else if(type == TransformationType.ANNOTATED)
			data += "ANNOTATED,";
		else if(type == TransformationType.PLAIN)
			data += "PLAIN,";
		data += completionPath;
		data += ",";
		data += configPath;
		data += ",";
		data += metamodel;
		return data;
		
	}
	
	public void readFromDataString(String data) {
		String[] dataStrings = data.split(",", -1);
		
		if(dataStrings[0].compareTo("true") == 0)
			enabled = true;
		else 
			enabled = false;
		
		if(dataStrings[1].compareTo("HOT") == 0)
			type = TransformationType.HOT;
		else if(dataStrings[1].compareTo("ANNOTATED") == 0)
			type = TransformationType.ANNOTATED;
		else if(dataStrings[1].compareTo("PLAIN") == 0)
			type = TransformationType.PLAIN;
		
		completionPath = dataStrings[2];
		configPath = dataStrings[3];
		metamodel = dataStrings[4];
	}
	
	public static Transformation fromDataString(String data) {
		Transformation transformation = new Transformation();
		transformation.readFromDataString(data);
		return transformation;
	}
}