package de.uka.ipd.sdq.cip.pcm.configuration;

import java.util.Map;

import de.uka.ipd.sdq.cip.configuration.CompletionConfiguration;
import de.uka.ipd.sdq.workflow.IJob;
import de.uka.ipd.sdq.workflow.pcm.configurations.AbstractPCMWorkflowRunConfiguration;
import de.uka.ipd.sdq.workflow.pcm.jobs.LoadPCMModelsIntoBlackboardJob;
import de.uka.ipd.sdq.workflow.pcm.jobs.ValidatePCMModelsJob;

public class PCMCompletionRunConfiguration extends CompletionConfiguration {

	public PCMCompletionRunConfiguration(AbstractPCMWorkflowRunConfiguration pcmconfig, Map<String, Object> configuration) {
		super(configuration);
		setInputPartitionName(LoadPCMModelsIntoBlackboardJob.PCM_MODELS_PARTITION_ID);
		setAfterJobs(new IJob[]{new ValidatePCMModelsJob(pcmconfig)});
	}

}
