package de.uka.ipd.sdq.cip.workflow.jobs.builder;

import java.util.Collection;

import de.uka.ipd.sdq.cip.ConstantsContainer;
import de.uka.ipd.sdq.cip.configuration.CompletionConfiguration;
import de.uka.ipd.sdq.cip.configuration.CompletionTransformationJobConfiguration;
import de.uka.ipd.sdq.cip.configuration.Transformation;
import de.uka.ipd.sdq.cip.workflow.jobs.CompletionTransformationJob;
import de.uka.ipd.sdq.workflow.IJob;
import de.uka.ipd.sdq.workflow.mdsd.blackboard.ResourceSetPartition;
import de.uka.ipd.sdq.workflow.mdsd.emf.qvtr.QVTRScript;

public class HotCompletionBuilder extends CompletionBuilder{
	
	public HotCompletionBuilder(CompletionConfiguration configuration, Transformation transformation) {
		super(configuration,transformation);
	}

	public Collection<IJob> buildJobs()
	{
		// HOT Completion: FeatureConfig -> HOT ->  Generated QVT Completion Script
		ResourceSetPartition outputResourceSetPartition = new ResourceSetPartition();
		ResourceSetPartition configResourceSetPartition = new ResourceSetPartition();
		
		CompletionTransformationJobConfiguration completionTransformationConfiguration = new CompletionTransformationJobConfiguration(
				configuration.getLastPartition(), outputResourceSetPartition, configResourceSetPartition, 
				getProject(configuration.getProjectID()).getFolder(ConstantsContainer.HOTTRACESFOLDER).getFullPath().toOSString(),
				getHotScript(), configuration.getDebug());
		jobs.add(new CompletionTransformationJob(completionTransformationConfiguration));
		configuration.setLastPartition(outputResourceSetPartition);
		
		// Completion: Input Model -> Generated QVT Completion Script -> Output Model  
		outputResourceSetPartition = new ResourceSetPartition();
		QVTRScript qvtrScript = new QVTRScript();
		//qvtrScript.setQVTFile();
		
		completionTransformationConfiguration = new CompletionTransformationJobConfiguration(
				configuration.getLastPartition(), outputResourceSetPartition, null, 
				getProject(configuration.getProjectID()).getFolder(ConstantsContainer.TRACESFOLDER).getFullPath().toOSString(),
				qvtrScript, configuration.getDebug());
		jobs.add(new CompletionTransformationJob(completionTransformationConfiguration));
		configuration.setLastPartition(outputResourceSetPartition);
		
		return jobs;
	}

	private QVTRScript getHotScript() {
		QVTRScript qvtrScript = new QVTRScript();
		qvtrScript.setQVTFile(ConstantsContainer.HOT_QVT_SCRIPT);
		return qvtrScript;
	}
}
