package de.uka.ipd.sdq.cip.workflow.jobs.builder;

import java.util.Collection;

import org.eclipse.emf.common.util.URI;

import de.uka.ipd.sdq.cip.ConstantsContainer;
import de.uka.ipd.sdq.cip.configuration.CompletionConfiguration;
import de.uka.ipd.sdq.cip.configuration.CompletionTransformationJobConfiguration;
import de.uka.ipd.sdq.cip.configuration.Transformation;
import de.uka.ipd.sdq.cip.workflow.jobs.CompletionTransformationJob;
import de.uka.ipd.sdq.workflow.IJob;
import de.uka.ipd.sdq.workflow.mdsd.blackboard.ResourceSetPartition;
import de.uka.ipd.sdq.workflow.mdsd.emf.qvtr.QVTRScript;

public class PlainCompletionBuilder extends CompletionBuilder {

	public PlainCompletionBuilder(CompletionConfiguration configuration, Transformation transformation) {
		super(configuration,transformation);
	}

	@Override
	public
	Collection<IJob> buildJobs() {
		
		// Completion: Input Model -> QVT Completion Script -> Output Model
		ResourceSetPartition configResourceSetPartition = null ;
		ResourceSetPartition outputResourceSetPartition = new ResourceSetPartition();
		outputResourceSetPartition.getResourceSet().createResource(URI.createURI(getProject(configuration.getProjectID()).getFolder(ConstantsContainer.MODELFOLDER).getFile("output.repository").toString()));
		
		Collection<Object> metamodels = configuration.getMetaModels();
		
		if(transformation.configPath != null) {
			configResourceSetPartition = createAndLoadPartition(new URI[] {URI.createURI(transformation.configPath)});
			metamodels.addAll(getEPackages(transformation.metamodel));
		}
		
		QVTRScript qvtrScript = createQVTScript(transformation.completionPath, metamodels, null, null);
		
		CompletionTransformationJobConfiguration completionTransformationConfiguration = new CompletionTransformationJobConfiguration(
				configuration.getLastPartition(), outputResourceSetPartition, configResourceSetPartition, 
				getProject(configuration.getProjectID()).getFolder(ConstantsContainer.TRACESFOLDER).getFullPath().toOSString(),
				qvtrScript, configuration.getDebug());
		jobs.add(new CompletionTransformationJob(completionTransformationConfiguration));
		configuration.setLastPartition(outputResourceSetPartition);
		
		return jobs;
		
		/*RelationalQVTJob job = new RelationalQVTJob();
		
		job.setDebug(true);
		job.setTracesPartitionName(ConstantsContainer.tracesPartition);
		
		IFolder tracesFolder = config.getProject().getFolder(ConstantsContainer.tracesFolder);
		
		if(!tracesFolder.exists())
			try {
				tracesFolder.create(true, true, null);
			} catch (CoreException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		setWorkingDirectory(tracesFolder.getRawLocationURI().toString());
		setDirection(ConstantsContainer.direction);
		setQvtFile(completionEntry.getType().getCompletionFile());
		setTransformation(null);
		
		createNewPartition(outputPartitionName, null, null);
		createNewPartition(ConstantsContainer.annotationPartition, new String[]{completionEntry.getFeatureFile()}, new String[]{completionEntry.getType().getAnnotationMetaFile()});
		
		IFolder intermediateFolder = config.getProject().getFolder(ConstantsContainer.outputFolder);
		if(!intermediateFolder.exists())ConstantsContainer.annotationPartition
			try {
				intermediateFolder.create(true, true, null);
			} catch (CoreException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		IFile partFile = intermediateFolder.getFile(prefix + "_output.repository");
		this.blackboard.getPartition(outputPartitionName).getResourceSet().createResource(URI.createFileURI(partFile.getFullPath().toString()));
		//outputPartition.getResourceSet().createResource(URI.createFileURI(partFile.getFullPath().toString()));
		
		partitions[0] = config.getModelPartition();
		partitions[1] = outputPartitionName;
		partitions[2] = ConstantsContainer.annotationPartition;
		
		setModelPartitionNames(partitions);
		
		return ArrayList<IJob> job.;*/
	}

}
