package de.uka.ipd.sdq.dsexplore.analysis;

import java.util.List;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.opt4j.core.Objective;

import de.uka.ipd.sdq.workflow.exceptions.JobFailedException;
import de.uka.ipd.sdq.workflow.exceptions.UserCanceledException;
import de.uka.ipd.sdq.workflow.mdsd.blackboard.MDSDBlackboard;

/**
 * 
 * TODO: Refactor this (after having refactored DSEWorkflowConfiguration, see there) 
 * and use DSE configuration classes instead of Eclipse ones.  
 * @author martens
 *
 */

public interface IAnalysis {

	/**
	 * Analyses the current PCM instance from the blackboard. 
	 * @return
	 * @throws CoreException
	 * @throws UserCanceledException 
	 * @throws JobFailedException 
	 * @throws AnalysisFailedException
	 */
	public abstract void analyse() throws CoreException, UserCanceledException, JobFailedException, AnalysisFailedException;

	 /**
	  * Saves the passed Run Configuration information so that we do not have to pass them as parameters all the time.
	  * @param blackboard the blackboard with the model to be analysed  
	  * @param configuration
	  * @param mode
	  * @param launch
	  * @param monitor
	 * @throws CoreException 
	  */
	public abstract void initialise(MDSDBlackboard blackboard, ILaunchConfiguration configuration, ILaunch launch,IProgressMonitor monitor) throws CoreException;

	public abstract IAnalysisResult retrieveLastResultsForObjective(Objective objective) throws CoreException, AnalysisFailedException;

	public abstract String getQualityAttribute() throws CoreException;
	
	public abstract boolean hasStatisticResults() throws CoreException;

	public abstract List<Objective> getObjectives() throws CoreException;
	
	

}
