/*
 * Copyright 2007, SDQ, IPD, Uni Karlsruhe (TH)
 */
package de.uka.ipd.sdq.pcm.gmf.composite.edit.parts;

import org.eclipse.draw2d.FigureUtilities;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gmf.runtime.diagram.ui.editparts.ITextAwareEditPart;
import org.eclipse.gmf.runtime.draw2d.ui.figures.WrapLabel;
import org.eclipse.gmf.runtime.notation.View;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Text;

import de.uka.ipd.sdq.pcm.gmf.composite.part.PalladioComponentModelVisualIDRegistry;

/**
 * @generated
 */
public class PalladioComponentModelEditPartFactory implements EditPartFactory {

	/**
	 * @generated
	 */
	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof View) {
			View view = (View) model;
			switch (PalladioComponentModelVisualIDRegistry.getVisualID(view)) {

			case ComposedProvidingRequiringEntityEditPart.VISUAL_ID:
				return new ComposedProvidingRequiringEntityEditPart(view);

			case ComposedProvidingRequiringEntity2EditPart.VISUAL_ID:
				return new ComposedProvidingRequiringEntity2EditPart(view);

			case ComposedProvidingRequiringEntityEntityNameEditPart.VISUAL_ID:
				return new ComposedProvidingRequiringEntityEntityNameEditPart(
						view);

			case AssemblyContextEditPart.VISUAL_ID:
				return new AssemblyContextEditPart(view);

			case AssemblyContextEntityNameEditPart.VISUAL_ID:
				return new AssemblyContextEntityNameEditPart(view);

			case ProvidedRoleEditPart.VISUAL_ID:
				return new ProvidedRoleEditPart(view);

			case ProvidedRoleEntityNameEditPart.VISUAL_ID:
				return new ProvidedRoleEntityNameEditPart(view);

			case RequiredRoleEditPart.VISUAL_ID:
				return new RequiredRoleEditPart(view);

			case RequiredRoleEntityNameEditPart.VISUAL_ID:
				return new RequiredRoleEntityNameEditPart(view);

			case ProvidedRole2EditPart.VISUAL_ID:
				return new ProvidedRole2EditPart(view);

			case ProvidedRoleEntityName2EditPart.VISUAL_ID:
				return new ProvidedRoleEntityName2EditPart(view);

			case RequiredRole2EditPart.VISUAL_ID:
				return new RequiredRole2EditPart(view);

			case RequiredRoleEntityName2EditPart.VISUAL_ID:
				return new RequiredRoleEntityName2EditPart(view);

			case ComposedProvidingRequiringEntityCompositeStructureInnerCompartmentEditPart.VISUAL_ID:
				return new ComposedProvidingRequiringEntityCompositeStructureInnerCompartmentEditPart(
						view);

			case AssemblyConnectorEditPart.VISUAL_ID:
				return new AssemblyConnectorEditPart(view);

			case RequiredDelegationConnectorEditPart.VISUAL_ID:
				return new RequiredDelegationConnectorEditPart(view);

			case ProvidedDelegationConnectorEditPart.VISUAL_ID:
				return new ProvidedDelegationConnectorEditPart(view);
			}
		}
		return createUnrecognizedEditPart(context, model);
	}

	/**
	 * @generated
	 */
	private EditPart createUnrecognizedEditPart(EditPart context, Object model) {
		// Handle creation of unrecognized child node EditParts here
		return null;
	}

	/**
	 * @generated
	 */
	public static CellEditorLocator getTextCellEditorLocator(
			ITextAwareEditPart source) {
		if (source.getFigure() instanceof WrapLabel)
			return new TextCellEditorLocator((WrapLabel) source.getFigure());
		else {
			return new LabelCellEditorLocator((Label) source.getFigure());
		}
	}

	/**
	 * @generated
	 */
	static private class TextCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private WrapLabel wrapLabel;

		/**
		 * @generated
		 */
		public TextCellEditorLocator(WrapLabel wrapLabel) {
			this.wrapLabel = wrapLabel;
		}

		/**
		 * @generated
		 */
		public WrapLabel getWrapLabel() {
			return wrapLabel;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getWrapLabel().getTextBounds().getCopy();
			getWrapLabel().translateToAbsolute(rect);
			if (getWrapLabel().isTextWrapped()
					&& getWrapLabel().getText().length() > 0) {
				rect.setSize(new Dimension(text.computeSize(rect.width,
						SWT.DEFAULT)));
			} else {
				int avr = FigureUtilities.getFontMetrics(text.getFont())
						.getAverageCharWidth();
				rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
						SWT.DEFAULT)).expand(avr * 2, 0));
			}
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}

	}

	/**
	 * @generated
	 */
	private static class LabelCellEditorLocator implements CellEditorLocator {

		/**
		 * @generated
		 */
		private Label label;

		/**
		 * @generated
		 */
		public LabelCellEditorLocator(Label label) {
			this.label = label;
		}

		/**
		 * @generated
		 */
		public Label getLabel() {
			return label;
		}

		/**
		 * @generated
		 */
		public void relocate(CellEditor celleditor) {
			Text text = (Text) celleditor.getControl();
			Rectangle rect = getLabel().getTextBounds().getCopy();
			getLabel().translateToAbsolute(rect);
			int avr = FigureUtilities.getFontMetrics(text.getFont())
					.getAverageCharWidth();
			rect.setSize(new Dimension(text.computeSize(SWT.DEFAULT,
					SWT.DEFAULT)).expand(avr * 2, 0));
			if (!rect.equals(new Rectangle(text.getBounds()))) {
				text.setBounds(rect.x, rect.y, rect.width, rect.height);
			}
		}
	}
}
